// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:srv/PlanRoute.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/srv/detail/plan_route__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `waypoints`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
marti_nav_msgs__srv__PlanRoute_Request__init(marti_nav_msgs__srv__PlanRoute_Request * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__srv__PlanRoute_Request__fini(msg);
    return false;
  }
  // waypoints
  if (!geometry_msgs__msg__Pose__Sequence__init(&msg->waypoints, 0)) {
    marti_nav_msgs__srv__PlanRoute_Request__fini(msg);
    return false;
  }
  // plan_from_vehicle
  return true;
}

void
marti_nav_msgs__srv__PlanRoute_Request__fini(marti_nav_msgs__srv__PlanRoute_Request * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // waypoints
  geometry_msgs__msg__Pose__Sequence__fini(&msg->waypoints);
  // plan_from_vehicle
}

marti_nav_msgs__srv__PlanRoute_Request *
marti_nav_msgs__srv__PlanRoute_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Request * msg = (marti_nav_msgs__srv__PlanRoute_Request *)allocator.allocate(sizeof(marti_nav_msgs__srv__PlanRoute_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__srv__PlanRoute_Request));
  bool success = marti_nav_msgs__srv__PlanRoute_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__srv__PlanRoute_Request__destroy(marti_nav_msgs__srv__PlanRoute_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_nav_msgs__srv__PlanRoute_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_nav_msgs__srv__PlanRoute_Request__Sequence__init(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Request * data = NULL;

  if (size) {
    data = (marti_nav_msgs__srv__PlanRoute_Request *)allocator.zero_allocate(size, sizeof(marti_nav_msgs__srv__PlanRoute_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__srv__PlanRoute_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__srv__PlanRoute_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__srv__PlanRoute_Request__Sequence__fini(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__srv__PlanRoute_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__srv__PlanRoute_Request__Sequence *
marti_nav_msgs__srv__PlanRoute_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Request__Sequence * array = (marti_nav_msgs__srv__PlanRoute_Request__Sequence *)allocator.allocate(sizeof(marti_nav_msgs__srv__PlanRoute_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__srv__PlanRoute_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__srv__PlanRoute_Request__Sequence__destroy(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_nav_msgs__srv__PlanRoute_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}


// Include directives for member types
// Member `route`
#include "marti_nav_msgs/msg/detail/route__functions.h"
// Member `message`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_nav_msgs__srv__PlanRoute_Response__init(marti_nav_msgs__srv__PlanRoute_Response * msg)
{
  if (!msg) {
    return false;
  }
  // route
  if (!marti_nav_msgs__msg__Route__init(&msg->route)) {
    marti_nav_msgs__srv__PlanRoute_Response__fini(msg);
    return false;
  }
  // success
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    marti_nav_msgs__srv__PlanRoute_Response__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__srv__PlanRoute_Response__fini(marti_nav_msgs__srv__PlanRoute_Response * msg)
{
  if (!msg) {
    return;
  }
  // route
  marti_nav_msgs__msg__Route__fini(&msg->route);
  // success
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

marti_nav_msgs__srv__PlanRoute_Response *
marti_nav_msgs__srv__PlanRoute_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Response * msg = (marti_nav_msgs__srv__PlanRoute_Response *)allocator.allocate(sizeof(marti_nav_msgs__srv__PlanRoute_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__srv__PlanRoute_Response));
  bool success = marti_nav_msgs__srv__PlanRoute_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__srv__PlanRoute_Response__destroy(marti_nav_msgs__srv__PlanRoute_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_nav_msgs__srv__PlanRoute_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_nav_msgs__srv__PlanRoute_Response__Sequence__init(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Response * data = NULL;

  if (size) {
    data = (marti_nav_msgs__srv__PlanRoute_Response *)allocator.zero_allocate(size, sizeof(marti_nav_msgs__srv__PlanRoute_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__srv__PlanRoute_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__srv__PlanRoute_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__srv__PlanRoute_Response__Sequence__fini(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__srv__PlanRoute_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__srv__PlanRoute_Response__Sequence *
marti_nav_msgs__srv__PlanRoute_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_nav_msgs__srv__PlanRoute_Response__Sequence * array = (marti_nav_msgs__srv__PlanRoute_Response__Sequence *)allocator.allocate(sizeof(marti_nav_msgs__srv__PlanRoute_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__srv__PlanRoute_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__srv__PlanRoute_Response__Sequence__destroy(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_nav_msgs__srv__PlanRoute_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
